Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.jgoodies.forms.builder
Class I15dPanelBuilder

    java.lang.Object
      com.jgoodies.forms.builder.AbstractFormBuilder
          com.jgoodies.forms.builder.PanelBuilder
              com.jgoodies.forms.builder.I15dPanelBuilder

Direct Known Subclasses:
  DefaultFormBuilder

    public class I15dPanelBuilder

extends PanelBuilder

A general purpose panel builder that uses the `FormLayout` to lay out `JPanel`s. In addition to its superclass `PanelBuilder` this class provides convenience behavior to map resource keys to their associated internationalized (i15d) strings when adding labels, titles and titled separators.

The localized texts used in methods `#addI15dLabel` and `#addI15dTitle` can contain an optional mnemonic marker. The mnemonic and mnemonic index are indicated by a single ampersand (`&`). For example `"&Save"`, or `"Save &as"`. To use the ampersand itself, duplicate it, for example `"Look&&Feel"`.

Since:
  1.0.3
Version:
  $Revision: 1.1 $
Author:
  Karsten Lentzsch
See Also:
  `ResourceBundle`

Constructor Summary
`I15dPanelBuilder(FormLayout layout, ResourceBundle bundle)` Constructs an instance of `I15dPanelBuilder` for the given layout.
`I15dPanelBuilder(FormLayout layout, ResourceBundle bundle, JPanel panel)` Constructs an instance of `I15dPanelBuilder` for the given FormLayout and layout container.
`I15dPanelBuilder(JPanel panel, FormLayout layout, ResourceBundle bundle)` Deprecated. Replaced by `I15dPanelBuilder(FormLayout, ResourceBundle, JPanel)`.

Method Summary
`JLabel` | `add15dTitle(String resourceKey, String encodedConstraints)` Adds a title to the form using the specified constraints.
`JLabel` | `addI15dLabel(String resourceKey, CellConstraints constraints)` Adds an internationalized (i15d) textual label to the form using the specified constraints.
`JLabel` | `addI15dLabel(String resourceKey, CellConstraints labelConstraints, Component component, CellConstraints componentConstraints)` Adds an internationalized (i15d) label and component to the panel using the given cell constraints.
`JLabel` | `addI15dLabel(String resourceKey, String encodedConstraints)` Adds an internationalized (i15d) textual label to the form using the specified constraints.
`JComponent` | `addI15dSeparator(String resourceKey, CellConstraints constraints)` Adds an internationalized (i15d) titled separator to the form using the specified constraints.
`JComponent` | `addI15dSeparator(String resourceKey, String encodedConstraints)` Adds an internationalized (i15d) titled separator to the form using the specified constraints.
`JLabel` | `addI15dTitle(String resourceKey, CellConstraints constraints)` Adds a title to the form using the specified constraints.
`protected String` | `getI15dString(String resourceKey)` Looks up and returns the internationalized (i15d) string for the given resource key from the `ResourceBundle`.

Methods inherited from class com.jgoodies.forms.builder.PanelBuilder
`add, addLabel, addLabel, addLabel, addLabel, addSeparator, addSeparator, addSeparator, addSeparator, addTitle, addTitle, addTitle, getComponentFactory, getPanel, setBorder, setComponentFactory, setDefaultDialogBorder`

Methods inherited from class com.jgoodies.forms.builder.AbstractFormBuilder
`add, add, add, appendColumn, appendColumn, appendGlueColumn, appendGlueRow, appendLabelComponentsGapColumn, appendParagraphGapRow, appendRelatedComponentsGapColumn, appendRelatedComponentsGapRow, appendRow, appendRow, appendUnrelatedComponentsGapColumn, appendUnrelatedComponentsGapRow, cellConstraints, createLeftAdjustedConstraints, getColumn, getColumnCount, getColumnIncrementSign, getContainer, getLayout, getLeadingColumn, getRow, getRowCount, isLeftToRight, nextColumn, nextColumn, nextLine, nextLine, nextRow, nextRow, setAlignment, setBounds, setColumn, setColumnSpan, setExtent, setHAlignment, setLeftToRight, setOrigin, setRow, setRowSpan, setVAlignment`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### I15dPanelBuilder

    public I15dPanelBuilder(FormLayout layout,
                            ResourceBundle bundle)

  Constructs an instance of `I15dPanelBuilder` for the given layout. Uses an instance of `JPanel` as layout container.

  Parameters:
    `layout` - the form layout used to layout the container
    `bundle` - the resource bundle used to lookup i15d strings

### I15dPanelBuilder

    public I15dPanelBuilder(FormLayout layout,
                            ResourceBundle bundle,
                            JPanel panel)

  Constructs an instance of `I15dPanelBuilder` for the given FormLayout and layout container.

  Parameters:
    `layout` - the `FormLayout` used to layout the container
    `bundle` - the `ResourceBundle` used to lookup i15d strings
    `panel` - the layout container

### I15dPanelBuilder

    public I15dPanelBuilder(JPanel panel,
                            FormLayout layout,
                            ResourceBundle bundle)

  Deprecated. Replaced by `I15dPanelBuilder(FormLayout, ResourceBundle, JPanel)`.

  Constructs an instance of `I15dPanelBuilder` for the given FormLayout and layout container.

  Parameters:
    `panel` - the layout container
    `bundle` - the `ResourceBundle` used to lookup i15d strings
    `layout` - the `FormLayout` used to layout the container

Method Detail

### addI15dLabel

    public final JLabel addI15dLabel(String resourceKey,
                                     CellConstraints constraints)

  Adds an internationalized (i15d) textual label to the form using the specified constraints.

  Parameters:
    `resourceKey` - the resource key for the label's text
    `constraints` - the label's cell constraints
  Returns:
    the added label

### addI15dLabel

    public final JLabel addI15dLabel(String resourceKey,
                                     String encodedConstraints)

  Adds an internationalized (i15d) textual label to the form using the specified constraints.

  Parameters:
    `resourceKey` - the resource key for the label's text
    `encodedConstraints` - a string representation for the constraints
  Returns:
    the added label

### addI15dLabel

    public final JLabel addI15dLabel(String resourceKey,
                                     CellConstraints labelConstraints,
                                     Component component,
                                     CellConstraints componentConstraints)

  Adds an internationalized (i15d) label and component to the panel using the given cell constraints. Sets the label as the component label using `JLabel.setLabelFor(java.awt.Component)`.

  Note: The `CellConstraints` objects for the label and the component must be different. Cell constraints are implicitly cloned by the `FormLayout` when added to the container. However, in this case you may be tempted to reuse a `CellConstraints` object in the same way as with many other builder methods that require a single `CellConstraints` parameter. The pitfall is that the methods `CellConstraints.xy**(...)` just set the coordinates but do not create a new instance. And so the second invocation of `xy***(...)` overrides the settings performed in the first invocation before the object is cloned by the `FormLayout`.

  Wrong:

       builder.add("name.key",
                   cc.xy(1, 7),         // will be modified by the code below
                   nameField,
                   cc.xy(3, 7)          // sets the single instance to (3, 7)
                  );

  Correct:

       builder.add("name.key",
                   cc.xy(1, 7).clone(), // cloned before the next modification
                   nameField,
                   cc.xy(3, 7)          // sets this instance to (3, 7)
                  );

  Parameters:
    `resourceKey` - the resource key for the label
    `labelConstraints` - the label's cell constraints
    `component` - the component to add
    `componentConstraints` - the component's cell constraints
  Returns:
    the added label
  Throws:
    `IllegalArgumentException` - if the same cell constraints instance is used for the label and the component
  See Also:
    `JLabel.setLabelFor(java.awt.Component)`

### addI15dSeparator

    public final JComponent addI15dSeparator(String resourceKey,
                                             CellConstraints constraints)

  Adds an internationalized (i15d) titled separator to the form using the specified constraints.

  Parameters:
    `resourceKey` - the resource key for the separator title
    `constraints` - the separator's cell constraints
  Returns:
    the added titled separator

### addI15dSeparator

    public final JComponent addI15dSeparator(String resourceKey,
                                             String encodedConstraints)

  Adds an internationalized (i15d) titled separator to the form using the specified constraints.

  Parameters:
    `resourceKey` - the resource key for the separator titel
    `encodedConstraints` - a string representation for the constraints
  Returns:
    the added titled separator

### addI15dTitle

    public final JLabel addI15dTitle(String resourceKey,
                                     CellConstraints constraints)

  Adds a title to the form using the specified constraints.

  Parameters:
    `resourceKey` - the resource key for the separator title
    `constraints` - the separator's cell constraints
  Returns:
    the added title label

### add15dTitle

    public final JLabel add15dTitle(String resourceKey,
                                    String encodedConstraints)

  Adds a title to the form using the specified constraints.

  Parameters:
    `resourceKey` - the resource key for the separator titel
    `encodedConstraints` - a string representation for the constraints
  Returns:
    the added title label

### getI15dString

    protected String getI15dString(String resourceKey)

  Looks up and returns the internationalized (i15d) string for the given resource key from the `ResourceBundle`.

  Parameters:
    `resourceKey` - the key to look for in the resource bundle
  Returns:
    the associated internationalized string, or the resource key itself in case of a missing resource
  Throws:
    `IllegalStateException` - if no `ResourceBundle` has been set

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2002-2006 JGoodies Karsten Lentzsch. All Rights Reserved.